Index: moodle/lang/en_utf8/moodle.php
--- moodle/lang/en_utf8/moodle.php Base (1.251)
+++ moodle/lang/en_utf8/moodle.php Locally Modified (Based On 1.251)
@@ -275,6 +275,7 @@
 $string['counteditems'] = '$a->count $a->items';
 $string['country'] = 'Country';
 $string['course'] = 'Course';
+$string['courseadministration'] = 'Course Administration';
 $string['courseapprovedemail'] = 'Your requested course, $a->name, has been approved and you have been made a $a->teacher.  To access your new course, go to $a->url';
 $string['courseapprovedemail2'] = 'Your requested course, $a->name, has been approved.  To access your new course, go to $a->url';
 $string['courseapprovedfailed'] = 'Failed to save the course as approved!';
@@ -731,6 +732,7 @@
 $string['frontpageformat'] = 'Front page format';
 $string['frontpageformatloggedin'] = 'Front page format when logged in';
 $string['frontpagenews'] = 'News items';
+$string['frontpagesettings'] = 'Front Page Settings';
 $string['frontpagetopiconly'] = 'Topic section';
 $string['fulllistofcourses'] = 'All courses';
 $string['fullname'] = 'Full name';
@@ -1034,6 +1036,7 @@
 $string['moreprofileinfoneeded'] = 'Please tell us more about yourself';
 $string['mostrecently'] = 'most recently';
 $string['move'] = 'Move';
+$string['moveallsidetabstoblock'] = 'Move all tabs back to their block position';
 $string['movecategoryto'] = 'Move category to:';
 $string['movecategorycontentto'] = 'Move into';
 $string['movecontentstoanothercategory'] = 'Move contents to another category';
@@ -1059,6 +1062,10 @@
 $string['nametopics'] = 'topic';
 $string['nameweeks'] = 'week';
 $string['nameweekscss'] = 'week';
+$string['navigationupgrade'] = 'Please note this upgrade introduces two new navigation blocks that are designed to replace previous blocks.<br />
+As part of this upgrade those blocks that have been replaced will be removed.<br />
+Because of this you may need to give your browser a strong refresh if you are missing some styles.<br />
+You may also need to re-apply any special permissions you may have had set on the following blocks: <ul><li>participants</li><li>courses</li><li>admin</li><li>admin_tree</li>';
 $string['needed'] = 'Needed';
 $string['never'] = 'Never';
 $string['neverdeletelogs'] = 'Never delete logs';
@@ -1355,6 +1362,7 @@
 $string['restoretositedeleting'] = 'Warning: You are about to restore to the site front page, deleting data from it first!';
 $string['restricted'] = 'Restricted';
 $string['restrictmodules'] = 'Restrict activity modules?';
+$string['returntooriginaluser'] = 'Return to $a';
 $string['returningtosite'] = 'Returning to this web site?';
 $string['revert'] = 'Revert';
 $string['role'] = 'Role';
@@ -1657,6 +1665,8 @@
 $string['usedinnplaces'] = 'Used in $a places';
 $string['usemessageform'] = 'or use the form below to send a message to the selected students';
 $string['user'] = 'User';
+$string['usercurrentsettings'] = 'My profile settings';
+$string['userviewingsettings'] = 'Profile for $a';
 $string['userconfirmed'] = 'Confirmed $a';
 $string['userdata'] = 'User Data';
 $string['userdeleted'] = 'This user account has been deleted';
@@ -1687,6 +1697,7 @@
 $string['version'] = 'Version';
 $string['view'] = 'View';
 $string['viewfileinpopup'] = 'View file in a popup window';
+$string['viewmyprofile'] = 'View my profile';
 $string['views'] = 'Views';
 $string['viewsolution'] = 'view solution';
 $string['virusfound'] = 'Attention administrator! Clam AV has found a virus in a file uploaded by $a->user for the course $a->course. Here is the output of clamscan:';
Index: moodle/lib/adminlib.php
--- moodle/lib/adminlib.php Base (1.386)
+++ moodle/lib/adminlib.php Locally Modified (Based On 1.386)
@@ -5082,15 +5082,9 @@
         $buttons = $OUTPUT->button(html_form::make_button($PAGE->url->out(false), $options, $caption, 'get'));
     }
 
-    $navlinks = array();
-    foreach ($visiblepathtosection as $element) {
-        $navlinks[] = array('name' => $element, 'link' => null, 'type' => 'misc');
+    print_header("$SITE->shortname: " . implode(": ",$visiblepathtosection), $SITE->fullname, array(), $focus, '', true, $buttons, '');
     }
-    $navigation = build_navigation($navlinks);
 
-    print_header("$SITE->shortname: " . implode(": ",$visiblepathtosection), $SITE->fullname, $navigation, $focus, '', true, $buttons, '');
-}
-
 /**
  * @deprecated since Moodle 1.9. Please use normal print_footer() instead
  */
@@ -5551,6 +5545,7 @@
                                         'comments',
                                         'course_list',
                                         'course_summary',
+                                        'global_navigation_tree',
                                         'glossary_random',
                                         'html',
                                         'loancalc',
@@ -5567,6 +5562,7 @@
                                         'search',
                                         'search_forums',
                                         'section_links',
+                                        'settings_navigation_tree',
                                         'site_main_menu',
                                         'social_activities',
                                         'tag_flickr',
Index: moodle/lib/ajax/getnavbranch.php
--- moodle/lib/ajax/getnavbranch.php No Base Revision
+++ moodle/lib/ajax/getnavbranch.php Locally New
@@ -0,0 +1,96 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * This file is used to deliver a branch from the navigation structure
+ * in XML format back to a page from an AJAX call
+ *
+ * @since 2.0
+ * @package moodlecore
+ * @copyright 2009 Sam Hemelryk
+ * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+/** Include config */
+require_once(dirname(__FILE__) . '/../../config.php');
+/** Include course lib for its functions */
+require_once($CFG->dirroot.'/course/lib.php');
+// Start buffer capture so that we can `remove` any errors
+ob_start();
+
+// Require elementid (this identifies which HTML element it is being expanded
+$elementid = optional_param('elementid', null, PARAM_INT);
+// Require id This is the key for whatever branch we want to get
+$branchid = optional_param('id', null, PARAM_INT);
+// This identifies the type of the branch we want to get
+$branchtype = optional_param('type', null, PARAM_INT);
+// This identifies the block instance requesting AJAX extension
+$instanceid = optional_param('instance', null, PARAM_INT);
+
+// Create a global nav object
+$navigation = new limited_global_navigation();
+// If set to true then we need to call toggle display
+$toggledisplay = false;
+if ($instanceid!==null) {
+    // Get the db record for the block instance
+    $blockrecords = $DB->get_record('block_instances', array('id'=>$instanceid,'blockname'=>'global_navigation_tree'));
+    if ($blockrecords!=false) {
+        // Instantiate a block_instance object so we can access congif
+        $block = block_instance('global_navigation_tree', $blockrecords);
+        // Check if the expansion limit config option has been set and isn't the default [everything]
+        if (!empty($block->config->expansionlimit) && $block->config->expansionlimit > '0') {
+            // Set the expansion limit
+            $navigation->expansionlimit = $block->config->expansionlimit;
+            $toggledisplay = true;
+        }
+        if (empty($block->config->showemptybranches) || $block->config->showemptybranches=='no') {
+            $navigation->showemptybranches = false;
+        }
+    }
+}
+
+// Create a navigation object to use, we can't guarantee PAGE will be complete
+$expandable = $navigation->initialise($branchtype, $branchid);
+
+if ($toggledisplay) {
+    // Toggle display of item types we dont' want to display
+    $navigation->toggle_type_display($navigation->expansionlimit);
+}
+// Find the actuall branch we are looking for
+$branch = $navigation->find_child($branchid, $branchtype);
+
+// Stop buffering errors at this point
+$html = ob_get_contents();
+ob_end_clean();
+
+// Check if the buffer contianed anything if it did ERROR!
+if (trim($html)!=='') {
+    die('Errors were encountered while producing the navigation branch'."\n\n\n".$html);
+}
+// Check that branch isn't empty... if it is ERROR!
+if (empty($branch) || $branch->nodetype !== navigation_node::NODETYPE_BRANCH) {
+    die('No further information available for this branch');
+}
+
+// Prepare an XML converter for the branch
+$converter = new navigation_xml();
+$converter->set_expandable($expandable);
+// Set XML headers
+header('Content-type: text/xml');
+echo '<?xml version="1.0" encoding="utf-8"?>';
+// Convert and output the branch as XML
+echo $converter->convert($branch);
Index: moodle/lib/ajax/setuserpref.php
--- moodle/lib/ajax/setuserpref.php Base (1.2)
+++ moodle/lib/ajax/setuserpref.php Locally Modified (Based On 1.2)
@@ -35,9 +35,6 @@
 require_once(dirname(__FILE__) . '/../../config.php');
 
 // Check access.
-if (!isloggedin()) {;
-    print_error('mustbeloggedin');
-}
 if (!confirm_sesskey()) {
     print_error('invalidsesskey');
 }
Index: moodle/lib/blocklib.php
--- moodle/lib/blocklib.php Base (1.215)
+++ moodle/lib/blocklib.php Locally Modified (Based On 1.215)
@@ -585,12 +585,12 @@
      * @param string $pagetypepattern optional. Passed to @see add_block()
      * @param string $subpagepattern optional. Passed to @see add_block()
      */
-    public function add_blocks($blocks, $pagetypepattern = NULL, $subpagepattern = NULL) {
+    public function add_blocks($blocks, $pagetypepattern = NULL, $subpagepattern = NULL, $showinsubcontexts=false, $weight=0) {
         $this->add_regions(array_keys($blocks));
         foreach ($blocks as $region => $regionblocks) {
             $weight = 0;
             foreach ($regionblocks as $blockname) {
-                $this->add_block($blockname, $region, $weight, false, $pagetypepattern, $subpagepattern);
+                $this->add_block($blockname, $region, $weight, $showinsubcontexts, $pagetypepattern, $subpagepattern);
                 $weight += 1;
             }
         }
@@ -1626,11 +1626,17 @@
     $blocks = array();
     $bits = explode(':', $blocksstr);
     if (!empty($bits)) {
-        $blocks[BLOCK_POS_LEFT] = explode(',', array_shift($bits));
+        $leftbits = trim(array_shift($bits));
+        if ($leftbits != '') {
+            $blocks[BLOCK_POS_LEFT] = explode(',', $leftbits);
     }
+    }
     if (!empty($bits)) {
-        $blocks[BLOCK_POS_RIGHT] = explode(',', array_shift($bits));
+        $rightbits =trim(array_shift($bits));
+        if ($rightbits != '') {
+            $blocks[BLOCK_POS_RIGHT] = explode(',', $rightbits);
     }
+    }
     return $blocks;
 }
 
@@ -1644,7 +1650,7 @@
         return blocks_parse_default_blocks_list($CFG->defaultblocks_site);
     } else {
         return array(
-            BLOCK_POS_LEFT => array('site_main_menu', 'admin_tree'),
+            BLOCK_POS_LEFT => array('site_main_menu'),
             BLOCK_POS_RIGHT => array('course_summary', 'calendar_month')
         );
     }
@@ -1682,8 +1688,8 @@
 
             } else {
                 $blocknames = array(
-                    BLOCK_POS_LEFT => array('participants', 'activity_modules', 'search_forums', 'admin', 'course_list'),
-                    BLOCK_POS_RIGHT => array('news_items', 'calendar_upcoming', 'recent_activity')
+                    BLOCK_POS_LEFT => array(),
+                    BLOCK_POS_RIGHT => array('search_forums', 'news_items', 'calendar_upcoming', 'recent_activity')
                 );
             }
         }
@@ -1706,5 +1712,6 @@
 function blocks_add_default_system_blocks() {
     $page = new moodle_page();
     $page->set_context(get_context_instance(CONTEXT_SYSTEM));
-    $page->blocks->add_blocks(array(BLOCK_POS_LEFT => array('admin_tree', 'admin_bookmarks')), 'admin-*');
+    $page->blocks->add_blocks(array(BLOCK_POS_LEFT => array('global_navigation_tree', 'settings_navigation_tree')), '*', null, true);
+    $page->blocks->add_blocks(array(BLOCK_POS_LEFT => array('admin_bookmarks')), 'admin-*', null, null, 2);
 }
Index: moodle/lib/db/upgrade.php
--- moodle/lib/db/upgrade.php Base (1.326)
+++ moodle/lib/db/upgrade.php Locally Modified (Based On 1.326)
@@ -2370,6 +2370,113 @@
         upgrade_main_savepoint($result, 2009072400);
     }
 
+    /**
+     * This upgrade is to set up the new navigation blocks that have been developed
+     * as part of Moodle 2.0
+     * Now I [Sam Hemelryk] hit a conundrum while exploring how to go about this
+     * as not only do we want to install the new blocks but we also want to set up
+     * default instances of them, and at the same time remove instances of the blocks
+     * that were/will-be outmoded by the two new navigation blocks.
+     * After talking it through with Tim Hunt {@link http://moodle.org/mod/cvsadmin/view.php?conversationid=3112}
+     * we decided that the best way to go about this was to put the bulk of the
+     * upgrade operation into core upgrade `here` but to let the plugins block
+     * still install the blocks.
+     * This leaves one hairy end in that we will create block_instances within the
+     * DB before the blocks themselves are created within the DB
+     */
+    if ($result && $oldversion < 2009082800) {
+
+        echo $OUTPUT->notification(get_string('navigationupgrade'));
+
+        // Get the system context so we can set the block instances to it
+        $syscontext = get_context_instance(CONTEXT_SYSTEM);
+
+        // An array to contain the new block instances we will create
+        $newblockinstances = array('globalnavigation'=>new stdClass,'settingsnavigation'=>new stdClass);
+        // The new global navigation block instance as a stdClass
+        $newblockinstances['globalnavigation']->blockname = 'global_navigation_tree';
+        $newblockinstances['globalnavigation']->parentcontextid = $syscontext->id; // System context
+        $newblockinstances['globalnavigation']->showinsubcontexts = true; // Show absolutly everywhere
+        $newblockinstances['globalnavigation']->pagetypepattern = '*'; // Thats right everywhere
+        $newblockinstances['globalnavigation']->subpagetypepattern = null;
+        $newblockinstances['globalnavigation']->defaultregion = BLOCK_POS_LEFT;
+        $newblockinstances['globalnavigation']->defaultweight = -10; // Try make this first
+        $newblockinstances['globalnavigation']->configdata = '';
+        // The new settings navigation block instance as a stdClass
+        $newblockinstances['settingsnavigation']->blockname = 'settings_navigation_tree';
+        $newblockinstances['settingsnavigation']->parentcontextid = $syscontext->id;
+        $newblockinstances['settingsnavigation']->showinsubcontexts = true;
+        $newblockinstances['settingsnavigation']->pagetypepattern = '*';
+        $newblockinstances['settingsnavigation']->subpagetypepattern = null;
+        $newblockinstances['settingsnavigation']->defaultregion = BLOCK_POS_LEFT;
+        $newblockinstances['settingsnavigation']->defaultweight = -9; // Try make this second
+        $newblockinstances['settingsnavigation']->configdata = '';
+
+        // Blocks that are outmoded and for whom the bells will toll... by which I
+        // mean we will delete all instances of
+        $outmodedblocks = array('participants','admin_tree','activity_modules','admin','course_list');
+        $outmodedblocksstring = '\''.join('\',\'',$outmodedblocks).'\'';
+        unset($outmodedblocks);
+        // Retrieve the block instance id's and parent contexts, so we can join them an GREATLY
+        // cut down the number of delete queries we will need to run
+        $allblockinstances = $DB->get_records_select('block_instances', 'blockname IN ('.$outmodedblocksstring.')', array(), '', 'id, parentcontextid');
+        
+        $contextids = array();
+        $instanceids = array();
+        // Iterate through all block instances
+        foreach ($allblockinstances as $blockinstance) {
+            if (!in_array($blockinstance->parentcontextid, $contextids)) {
+                $contextids[] = $blockinstance->parentcontextid;
+
+                // Look at {@link blocklib.php::blocks_delete_instance()} the function from
+                // which I based this code. It is important to mention one very important fact
+                // before doing this I checked that the blocks did not override the
+                // {@link block_base::instance_delete()} method. Should this function ever
+                // be repeated check this again
+                if (count($contextids) > 1000) {
+                    $result = $result && cleanup_unwanted_block_contexts($contextids);
+                    $contextids = array();
+                }
+            }
+            if (!in_array($blockinstance->id, $instanceids)) {
+                $instanceids[] = $blockinstance->id;
+                // If we have more than 1000 block instances now remove all block positions
+                // and empty the array
+                if (count($contextids) > 1000) {
+                    $instanceidstring = join(',',$instanceids);
+                    $result = $result && $DB->delete_records_select('block_positions', 'blockinstanceid IN ('.$instanceidstring.')');
+                    $instanceids = array();
+                }
+            }
+        }
+
+        $result = $result && cleanup_unwanted_block_contexts($contextids);
+
+        $instanceidstring = join(',',$instanceids);
+        $outcome1 = $result && $DB->delete_records_select('block_positions', 'blockinstanceid IN ('.$instanceidstring.')');
+        
+        unset($allblockinstances);
+        unset($contextids);
+        unset($instanceids);
+        unset($instanceidstring);
+        
+        // Now remove the actual block instance
+        $result = $result && $DB->delete_records_select('block_instances', 'blockname IN ('.$outmodedblocksstring.')');
+        unset($outmodedblocksstring);
+
+        // Insert the new block instances. Remember they have not been installed yet
+        // however this should not be a problem
+        foreach ($newblockinstances as $blockinstance) {
+            $blockinstance->id= $DB->insert_record('block_instances', $blockinstance);
+            // Ensure the block context is created.
+            get_context_instance(CONTEXT_BLOCK, $blockinstance->id);
+        }
+        unset($newblockinstances);
+        
+        upgrade_main_savepoint($result, 2009082800);
+        // The end of the navigation upgrade
+    }
+
     return $result;
 }
 
Index: moodle/lib/db/upgradelib.php
--- moodle/lib/db/upgradelib.php Base (1.25)
+++ moodle/lib/db/upgradelib.php Locally Modified (Based On 1.25)
@@ -331,4 +331,46 @@
     }
 }
 
+/**
+ * This function is used as part of the great navigation upgrade of 20090828
+ * It is used to clean up contexts that are unique to a blocks that are about
+ * to be removed.
+ *
+ * @link lib/db/upgrade.php
+ *
+ * @since navigation upgrade 20090828
+ * @param array $contextidarray An array of block instance context ids
+ * @return bool
+ */
+function cleanup_unwanted_block_contexts($contextidarray) {
+    global $DB;
+
+    if (!is_array($contextidarray) || count($contextidarray)===0) {
+        // Ummmm no instances?
+        return true;
+    }
+
+    $contextidstring = join(',', $contextidarray);
+
+    $blockcontexts = $DB->get_records_select('context', 'contextlevel = '.CONTEXT_BLOCK.' AND id IN ('.$contextidstring.')', array(), '', 'id, contextlevel');
+    $blockcontextids = array();
+    foreach ($blockcontexts as $blockcontext) {
+        $blockcontextids[] = $blockcontext->id;
+    }
+
+    if (count($blockcontextids)===0) {
+        // None of the instances have unique contexts
+        return true;
+    }
+
+    $blockcontextidsstring = join(',', $blockcontextids);
+
+    $outcome1 = $DB->delete_records_select('role_assignments', 'contextid IN ('.$blockcontextidsstring.')');
+    $outcome2 = $DB->delete_records_select('role_capabilities', 'contextid IN ('.$blockcontextidsstring.')');
+    $outcome3 = $DB->delete_records_select('role_names', 'contextid IN ('.$blockcontextidsstring.')');
+    $outcome4 = $DB->delete_records_select('context', 'id IN ('.$blockcontextidsstring.')');
+
+    return ($outcome1 && $outcome2 && $outcome4 && $outcome4);
+}
+
 ?>
Index: moodle/lib/deprecatedlib.php
--- moodle/lib/deprecatedlib.php Base (1.170)
+++ moodle/lib/deprecatedlib.php Locally Modified (Based On 1.170)
@@ -2133,15 +2133,6 @@
     }
     $PAGE->set_button($button);
 
-    if ($navigation == 'home') {
-        $navigation = '';
-    }
-    if (gettype($navigation) == 'string' && strlen($navigation) != 0 && $navigation != 'home') {
-        debugging("print_header() was sent a string as 3rd ($navigation) parameter. "
-                . "This is deprecated in favour of an array built by build_navigation(). Please upgrade your code.", DEBUG_DEVELOPER);
-    }
-
-    // TODO $navigation
     // TODO $menu
 
     if ($meta) {
@@ -2155,7 +2146,7 @@
         throw new coding_exception('The $bodytags parameter to print_header is no longer supported.');
     }
 
-    $output = $OUTPUT->header($navigation, $menu);
+    $output = $OUTPUT->header($menu);
 
     if ($return) {
         return $output;
@@ -3564,3 +3555,118 @@
     return $OUTPUT->edit_button(new moodle_url($CFG->wwwroot.'/course/view.php', array('id' => $courseid)));
 }
 
+/**
+ * Prints breadcrumb trail of links, called in theme/-/header.html
+ *
+ * This function has now been deprecated please use output's navbar method instead
+ * as shown below
+ *
+ * <code php>
+ * echo $OUTPUT->navbar();
+ * </code>
+ *
+ * @deprecated since 2.0
+ * @param mixed $navigation deprecated
+ * @param string $separator OBSOLETE, and now deprecated
+ * @param boolean $return False to echo the breadcrumb string (default), true to return it.
+ * @return string|void String or null, depending on $return.
+ */
+function print_navigation ($navigation, $separator=0, $return=false) {
+    global $OUTPUT,$PAGE;
+
+    # debugging('print_navigation has been deprecated please update your theme to use $OUTPUT->navbar() instead', DEBUG_DEVELOPER);
+
+    $output = $OUTPUT->navbar();
+
+    if ($return) {
+        return $output;
+    } else {
+        echo $output;
+    }
+}
+
+/**
+ * This function will build the navigation string to be used by print_header
+ * and others.
+ *
+ * It automatically generates the site and course level (if appropriate) links.
+ *
+ * If you pass in a $cm object, the method will also generate the activity (e.g. 'Forums')
+ * and activityinstances (e.g. 'General Developer Forum') navigation levels.
+ *
+ * If you want to add any further navigation links after the ones this function generates,
+ * the pass an array of extra link arrays like this:
+ * array(
+ *     array('name' => $linktext1, 'link' => $url1, 'type' => $linktype1),
+ *     array('name' => $linktext2, 'link' => $url2, 'type' => $linktype2)
+ * )
+ * The normal case is to just add one further link, for example 'Editing forum' after
+ * 'General Developer Forum', with no link.
+ * To do that, you need to pass
+ * array(array('name' => $linktext, 'link' => '', 'type' => 'title'))
+ * However, becuase this is a very common case, you can use a shortcut syntax, and just
+ * pass the string 'Editing forum', instead of an array as $extranavlinks.
+ *
+ * At the moment, the link types only have limited significance. Type 'activity' is
+ * recognised in order to implement the $CFG->hideactivitytypenavlink feature. Types
+ * that are known to appear are 'home', 'course', 'activity', 'activityinstance' and 'title'.
+ * This really needs to be documented better. In the mean time, try to be consistent, it will
+ * enable people to customise the navigation more in future.
+ *
+ * When passing a $cm object, the fields used are $cm->modname, $cm->name and $cm->course.
+ * If you get the $cm object using the function get_coursemodule_from_instance or
+ * get_coursemodule_from_id (as recommended) then this will be done for you automatically.
+ * If you don't have $cm->modname or $cm->name, this fuction will attempt to find them using
+ * the $cm->module and $cm->instance fields, but this takes extra database queries, so a
+ * warning is printed in developer debug mode.
+ *
+ * @deprecated since 2.0
+ * @param mixed $extranavlinks - Normally an array of arrays, keys: name, link, type. If you
+ *      only want one extra item with no link, you can pass a string instead. If you don't want
+ *      any extra links, pass an empty string.
+ * @param mixed $cm deprecated
+ * @return array Navigation array
+ */
+function build_navigation($extranavlinks, $cm = null) {
+    global $CFG, $COURSE, $DB, $SITE, $PAGE;
+
+    if (is_array($extranavlinks) && count($extranavlinks)>0) {
+        # debugging('build_navigation() has been deprecated, please replace with $PAGE->navbar methods', DEBUG_DEVELOPER);
+        foreach ($extranavlinks as $nav) {
+            if (array_key_exists('name', $nav)) {
+                $link = (array_key_exists('link', $nav))?$nav['link']:null;
+                $PAGE->navbar->add($nav['name'],null, null, navbar::TYPE_CUSTOM, $link);
+            }
+        }
+    }
+    
+    return(array('newnav' => true, 'navlinks' => array()));
+}
+
+/**
+ * Returns a small popup menu of course activity modules
+ *
+ * Given a course and a (current) coursemodule
+ * his function returns a small popup menu with all the
+ * course activity modules in it, as a navigation menu
+ * The data is taken from the serialised array stored in
+ * the course record
+ *
+ * @global object
+ * @global object
+ * @global object
+ * @global object
+ * @uses CONTEXT_COURSE
+ * @param object $course A {@link $COURSE} object.
+ * @param object $cm A {@link $COURSE} object.
+ * @param string $targetwindow The target window attribute to us
+ * @return string
+ */
+function navmenu($course, $cm=NULL, $targetwindow='self') {
+    global $CFG, $THEME, $USER, $DB, $OUTPUT;
+
+    // This function has been deprecated with the creation of the global nav in
+    // moodle 2.0
+
+    return '';
+}
